import shutil, sys
import time
def progressbar(func):
    def _func_with_progress(*args, **kwargs):
        max_width, _ = shutil.get_terminal_size()
        gen = func(*args, **kwargs)
        while True:
            try:
                progress = next(gen)
            except StopIteration as exc:
                sys.stdout.write('\n')
                return exc.value
            else:
                message = '[%s] {}%%'.format(progress)
                bar_width = max_width - len(message) + 3  
                filled = int(round(bar_width / 100.0 * progress))
                spaceleft = bar_width - filled
                bar = '=' * filled + ' ' * spaceleft
                sys.stdout.write((message+'\r') % bar)
                sys.stdout.flush()
    return _func_with_progress
@progressbar
def wait(seconds):
    start = time.time()
    step = seconds / 100.
    for i in range(1, 101):
        time.sleep(step)
    return time.time() - start
if __name__ == '__main__':
    print("Waiting", wait(4))